# -*- coding: cp1252 -*-
'''
Created on 28 aug 2012

@author: Dan Torberg

Modul innehllande klassen Message som anvnds fr att skicka meddelanden till skrmen och kontrollera hur lnge de ska visas.
Tar emot ett textobjekt, x och y kordinater samt tiden i "frames" som objektet ska vara aktivt. Update()-metoden rknar upp en rknare
till dess att den valda tiden r uppndd och tar sedan bort objektet ur spelet.
'''
import pygame
from pygame.locals import *

pygame.font.init()
font = pygame.font.Font(None, 28)

class Message(pygame.sprite.Sprite):
    
    def __init__(self, text, x, y, duration):
        pygame.sprite.Sprite.__init__(self)
        self.text = text
        self.x = x
        self.y = y
        self.duration = duration
        self.frame = 0
        
    def update(self, sprites, screen):
        if self.frame == self.duration:
            sprites.remove(self)
        else:
            self.frame += 1
            
    def draw(self, screen):
        screen.blit(self.text, (self.x, self.y))